#include <cpctelera.h>
#include "main.h"
#include "font_utils.h"
#include "render.h"
#include "teclado.h"
#include "map_utils.h"
#include "tiles/tiles8x8.h"
#include "sprites/item_hechizo_rotate.h"
#include "sprites/item_vida_rotate.h"
#include "sprites/item_cambio_rotate.h"
#include "sprites/item_random_rotate.h"
#include "sprites/jugador_mago0.h"
#include "sprites/jugador_mago1.h"
#include "sprites/jugador_rana.h"
#include "sprites/jugador_larcenas.h"
#include "sprites/jugador_bruja.h"
#include "sprites/jugador_zombie.h"
#include "sprites/arrow_small_up.h"
#include "sprites/bin/jugador_mago0.h"
#include "menu.h"
#include "memory.h"


// ICONO DE SWITCH ACTIVADOR DE TRAMPAS
#define SP_ITEM_SWITCH_W    4
#define SP_ITEM_SWITCH_H    8

// ==============================================================
// GIRA EL SPRITE DE LA FLECHA DE DESPLAZAMIENTO ENTRE ESCENARIOS
// ==============================================================
void giraSpriteFlechaHorizontal() {
    cpct_hflipSpriteM0(SP_ARROW_SMALL_LEFT_W, SP_ARROW_SMALL_LEFT_H, sp_arrow_small_left); 
}

// ==============================================================
// DIBUJA TODA LA PANTALLA DE INSTRUCCIONES
// ==============================================================
void instrucciones() {
    u8 x, y, step, x1, x2, xBruja, yBruja, yItems, cambiaFrame;
    u16 i, mueveHechizo;

    u8 controls1[5][4] = {
         "1 -"
        ,"Q -"
        ,"D -"
        ,"F -"
        ,"Z -"
    };
    u8 controls2[5][5] = {
         "- F7"
        ,"- F4"
        ,"- F2"
        ,"- F3"
        ,"- F0"
    };

    mueveHechizo = i = 0;

    borraPantallas();
    printTxt(GAME_VERSION, 70, 194, NO, 2);

    printTxt("INSTRUCTIONS", CENTRADO, 1, NO, 10);
    subrayar(27,6,25);

    step = 8; y = 17;
        printTxt("CAST CRAZY SPELLS AGAINST", CENTRADO, y , NO, 0);
        printTxt("YOUR OPPONENT IN ORDER TO WIN", CENTRADO, y + step, NO, 0);

    step = 10;
    x = 6; y = 50;
        printTxt("DEFAULT CONTROLS", x, y, NO, 10);
        subrayar(x-1, y+5, 32);
        //printTxt(",,,,,,,,,,,,,,,,,", x-1, y+5, SI, 10);
    x = 52;
        printTxt("4 DIR. FIRE", x, y, NO, 10);
        subrayar(x-1, y+5, 23);
        //printTxt(",,,,,,,,,,,,", x-1, y+5, SI, 10);
  
    x = 20; y = 66; x2 = 61;
    // Flecha Arriba
    cpct_drawSprite (sp_arrow_small_up, cpct_getScreenPtr(VMEM_BUFFER1, x, y), SP_ARROW_SMALL_UP_W, SP_ARROW_SMALL_UP_H);
    cpct_drawSprite (sp_arrow_small_up, cpct_getScreenPtr(VMEM_BUFFER1, x2, y), SP_ARROW_SMALL_UP_W, SP_ARROW_SMALL_UP_H);
    
    // Flecha Abajo
    cpct_drawSpriteVFlip (sp_arrow_small_up, cpct_getBottomLeftPtr(cpct_getScreenPtr(VMEM_BUFFER1, x, y + step), SP_ARROW_SMALL_UP_H), SP_ARROW_SMALL_UP_W, SP_ARROW_SMALL_UP_H);
    cpct_drawSpriteVFlip (sp_arrow_small_up, cpct_getBottomLeftPtr(cpct_getScreenPtr(VMEM_BUFFER1, x2, y + 45), SP_ARROW_SMALL_UP_H), SP_ARROW_SMALL_UP_W, SP_ARROW_SMALL_UP_H);

    // Flecha iquierda
    cpct_drawSprite (sp_arrow_small_left, cpct_getScreenPtr(VMEM_BUFFER1, x, y + (step * 2)), SP_ARROW_SMALL_LEFT_W, SP_ARROW_SMALL_LEFT_H);
    cpct_drawSprite (sp_arrow_small_left, cpct_getScreenPtr(VMEM_BUFFER1, x2 - 8, y + 24), SP_ARROW_SMALL_LEFT_W, SP_ARROW_SMALL_LEFT_H);

    // Flecha derecha
    giraSpriteFlechaHorizontal();
    cpct_drawSprite (sp_arrow_small_left, cpct_getScreenPtr(VMEM_BUFFER1, x, y + (step * 3)), SP_ARROW_SMALL_LEFT_W, SP_ARROW_SMALL_LEFT_H);
    cpct_drawSprite (sp_arrow_small_left, cpct_getScreenPtr(VMEM_BUFFER1, x2 + 8, y + 24), SP_ARROW_SMALL_LEFT_W, SP_ARROW_SMALL_LEFT_H);
    giraSpriteFlechaHorizontal();

    // Hechizo
    cpct_drawSprite (sp_hechizo_0, cpct_getScreenPtr(VMEM_BUFFER1, x, y + (step * 4)), SP_HECHIZO_0_W, SP_HECHIZO_0_H);
    
    // Controles
    x = 10;
    for (i = 0; i < 5; i++) {
        printTxt(controls1[i], x, y + (step * i), NO, 0);
        printTxt(controls2[i], x + 18, y + (step * i), NO, 0);
    }
    printTxt("<OR JOY>", x + 5, y + (step * 5), NO, 0);

    // ITEMS
    yItems = 135;
        printTxt("ITEMS", CENTRADO, yItems, NO, 10);
        subrayar(34, yItems+5, 11);

    x = 17; yItems = yItems + 16; step = 9;
        printTxt("- EARN SPELL SHOTS", x, yItems, NO, 0);
        printTxt("- EARN 1 LIFE", x, yItems + step, NO, 0);
        printTxt("- CHARACTER SWAP", x, yItems + (step * 2), NO, 0);
        printTxt("- STRANGE THINGS MAY HAPPEN", x, yItems + (step * 3), NO, 0);
        printTxt("- TRAP ACTIVATOR", x, yItems + (step * 4), NO, 0);

    {
        // Icono del switch
        u8 sp_item_switch[SP_ITEM_SWITCH_W * SP_ITEM_SWITCH_H] = {
            0x00, 0x00, 0xaa, 0x00,
            0x00, 0x15, 0x5f, 0x00,
            0x00, 0x15, 0x5f, 0x00,
            0x00, 0x00, 0xaa, 0x00,
            0x15, 0x15, 0xff, 0x55,
            0x00, 0x00, 0xaa, 0x00,
            0x00, 0x00, 0xaa, 0x00,
            0x00, 0x00, 0xaa, 0x00 
        };
        
        cpct_drawSprite (sp_item_switch, cpct_getScreenPtr (VMEM_BUFFER1, 11, yItems + (step * 4)), SP_ITEM_SWITCH_W, SP_ITEM_SWITCH_H);
    }

    // SELECCIONAR SKIN DEL MAGO 0 (IZQUIERDA)
    seleccionarSkin(0, SKIN_MAGO0);

    // Sprites de bruja y direcciones                
    mueveHechizo = cambiaFrame = 0;
    x1 = 2; x2 = 40; y = 70;

    vaciaBufferTeclado();
    do {
        /// Mover la bruja y el hechizo
        xBruja = 61;
        yBruja = 84;
        
        if (mueveHechizo % 3000 == 0) {

            seleccionarSkin(1, SKIN_BRUJA);
            if (mueveHechizo == 0) {
                // Derecha -----------
                        cpct_drawSolidBox(cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja+18), 0, SP_HECHIZO_0_W, SP_HECHIZO_0_H);
                        cpct_drawSprite (jugador[1].sprite_disparando, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja), SP_MAGO0_0_W, SP_MAGO0_0_H);
                        cpct_drawSprite (sp_hechizo_0, cpct_getScreenPtr(VMEM_BUFFER1, xBruja+4, yBruja+7), SP_HECHIZO_0_W, SP_HECHIZO_0_H);
            }
            if (mueveHechizo == 3000) {
                // Arriba ------------
                        cpct_drawSolidBox(cpct_getScreenPtr(VMEM_BUFFER1, xBruja+4, yBruja+7), 0, SP_HECHIZO_0_W, SP_HECHIZO_0_H);
                        cpct_drawSprite (jugador[1].sprite_escala_frame1, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja), SP_MAGO0_0_W, SP_MAGO0_0_H);
                        cpct_drawSprite (sp_hechizo_0, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja-8), SP_HECHIZO_0_W, SP_HECHIZO_0_H);
            }
            if (mueveHechizo == 6000) {
                // Iquierda ------------
                        cpct_drawSolidBox(cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja-8), 0, SP_HECHIZO_0_W, SP_HECHIZO_0_H);
                        girarSpritesJugador(1);
                        cpct_drawSprite (jugador[1].sprite_disparando, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja), SP_MAGO0_0_W, SP_MAGO0_0_H);
                        girarSpritesJugador(1);
                        cpct_drawSprite (sp_hechizo_0, cpct_getScreenPtr(VMEM_BUFFER1, xBruja-4, yBruja+7), SP_HECHIZO_0_W, SP_HECHIZO_0_H);
            }
            if (mueveHechizo == 9000) {
                // Abajo ------------
                        cpct_drawSolidBox(cpct_getScreenPtr(VMEM_BUFFER1, xBruja-4, yBruja+7), 0, SP_HECHIZO_0_W, SP_HECHIZO_0_H);
                        cpct_drawSprite (jugador[1].sprite_herido, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja), SP_MAGO0_0_W, SP_MAGO0_0_H);
                        cpct_drawSprite (sp_hechizo_0, cpct_getScreenPtr(VMEM_BUFFER1, xBruja, yBruja+18), SP_HECHIZO_0_W, SP_HECHIZO_0_H);
            }
        }
        if (++ mueveHechizo == 12000) mueveHechizo = 0;

        // Iconos de los Items
        if (++cambiaFrame == 1) {
            if (++i > 3) i = 0;
            // ITEMS
            cpct_drawSprite((u8*) &sp_item_hechizo_rotate_0[0]  + (SP_ITEM_HECHIZO_ROTATE_0_W * SP_ITEM_HECHIZO_ROTATE_0_H * i),  cpct_getScreenPtr(VMEM_BUFFER1, 11, yItems),                SP_ITEM_HECHIZO_ROTATE_0_W, SP_ITEM_HECHIZO_ROTATE_0_H);
            cpct_drawSprite((u8*) &sp_item_vida_rotate_0[0]     + (SP_ITEM_HECHIZO_ROTATE_0_W * SP_ITEM_HECHIZO_ROTATE_0_H * i),  cpct_getScreenPtr(VMEM_BUFFER1, 11, yItems + step),         SP_ITEM_HECHIZO_ROTATE_0_W, SP_ITEM_HECHIZO_ROTATE_0_H);
            cpct_drawSprite((u8*) &sp_item_cambio_rotate_0[0]   + (SP_ITEM_HECHIZO_ROTATE_0_W * SP_ITEM_HECHIZO_ROTATE_0_H * i),  cpct_getScreenPtr(VMEM_BUFFER1, 11, yItems + (step * 2)),   SP_ITEM_HECHIZO_ROTATE_0_W, SP_ITEM_HECHIZO_ROTATE_0_H);
            cpct_drawSprite((u8*) &sp_item_random_rotate_0[0]   + (SP_ITEM_HECHIZO_ROTATE_0_W * SP_ITEM_HECHIZO_ROTATE_0_H * i),  cpct_getScreenPtr(VMEM_BUFFER1, 11, yItems + (step * 3)),   SP_ITEM_HECHIZO_ROTATE_0_W, SP_ITEM_HECHIZO_ROTATE_0_H);

            // MAGOS
            seleccionarSkin(1, SKIN_MAGO1);
            cpct_drawSprite(jugador[0].sprite_frame[i % 2], cpct_getScreenPtr(VMEM_BUFFER1, x1, y + step), SP_MAGO0_0_W, SP_MAGO0_0_H);  
            girarSpritesJugador(1);
            cpct_drawSprite(jugador[1].sprite_frame[i % 2], cpct_getScreenPtr(VMEM_BUFFER1, x2, y + step), SP_MAGO0_0_W, SP_MAGO0_0_H);
            girarSpritesJugador(1);
        }

        cpct_scanKeyboard();
    } while (!cpct_isAnyKeyPressed());

    sonidoTecla();
    girarSpritesJugador(1);
}