#define GAME_VERSION            "<1.0>"

// JUEGO
#define NUM_JUGADORES            2
#define NUM_MAPAS                5
#define NUM_MAPA_RANDOM          NUM_MAPAS + 1
#define NUM_SELECT_STAGES        NUM_MAPAS + 1
#define MAX_OBJETOS             10
#define MAX_OBJETOS_HECHIZO      2
#define MAX_OBJETOS_ITEM         5
#define HECHIZOS_INICIALES       5
#define VIDAS_INICIALES          3
#define TIEMPO_DISPARANDO       60
#define TIEMPO_HERIDO           35

// TIEMPOS DEL CONTACTO CON PINCHOS
#define TIEMPO_RESPAWN               100
#define TIEMPO_RESPAWN_GIRA1         85
#define TIEMPO_RESPAWN_GIRA2         70
#define TIEMPO_RESPAWN_RECOLOCA      55
#define TIEMPO_RESPAWN_GIRA3         40
#define TIEMPO_RESPAWN_GIRA4         25
#define TIEMPO_RESPAWN_REAPARECE     12

#define TIEMPO_TRANSFORMANDO        18
#define TIEMPO_DESTRUIR_HECHIZO     10
#define MAX_HECHIZOS                5
#define MAX_VIDAS                   5

// VELOCIDAD A LA QUE SE MUEVEN LOS PERSONAJES. MAS ALTO = MAS LENTO. ENTRE 1 Y MAX_BUCLE_CICLOS
#define VEL_RETARDO_ZOMBIE      4  
#define VEL_RETARDO_MAGO        2
#define VEL_RETARDO_RANA        2
#define VEL_RETARDO_LARCENAS    3
#define VEL_RETARDO_BRUJA       2

// SKINS DE LOS JUGADORES
#define SKINS_DIFERENTES    6
#define SKIN_MAGO0          0
#define SKIN_MAGO1          1
#define SKIN_LARCENAS       2
#define SKIN_RANA           3
#define SKIN_ZOMBIE         4
#define SKIN_BRUJA          5
#define SKIN_RANDOM        99

// TIPOS DE ITEMS
#define ITEM_HECHIZO        1
#define ITEM_VIDA           2
#define ITEM_CAMBIO         3
#define ITEM_RANDOM         4

// PROBABILIDADES DE QUE APAREZCAN ITEMS NUEVOS EN PANTALLA
#define ITEM_SPAWN_BASE            200
#define ITEM_SPAWN_BASE_NOSPELLS    40
#define ITEM_SPAWNS_LOWER_THAN      10
// PROBABILIDAD DE QUE APAREZCAN ITEMS DE RECARGAR HECHIZO
#define ITEM_SPAWNS_SPELL_PROBAB    2 // Cuántas veces más probable que aparezca un item tipo spell que los otros

// TIPOS DE DISPAROS
#define DISPARO_HECHIZO     3

// MAPA Y AREA DE JUEGO
#define AREA_JUEGO_SUP      48
#define AREA_JUEGO_INF      190
#define AREA_JUEGO_IZQ      0
#define AREA_JUEGO_DER      80
#define MAPA_W              20      // Columnas de tiles en total
#define MAPA_H              18      // Filas de tiles en total
#define TILES_TOTALES       MAPA_W * MAPA_H

// CLASIFICACION DE TILES (Restamos 2 para tener que hacer sólo una comparación en los cálculos de tiles, y porque además empiezan a numerarse en 0)
#define PRIMER_TILE_OBSTACULO   24   - 2
#define PRIMER_TILE_PLATAFORMA  17   - 2
#define PRIMER_TILE_ESCALERA    13   - 2
#define NUM_TILE_SWITCH         11
#define PRIMER_TILE_PINCHOS     11   - 2
#define NUM_TILE_SWITCH_ON      11
#define NUM_TILE_SWITCH_OFF      6

// TIPO DE TILES PARA COLISIONES
#define NADA                0
#define PINCHOS             1
#define SWITCH              2
#define ESCALERAS           3
#define PLATAFORMA          4
#define OBSTACULO           5


// MOVIMIENTO Y DIRECCIONES
#define IZQUIERDA              -1
#define DERECHA                 1
#define PARADO                  0
#define ARRIBA                 -1
#define ABAJO                   1
#define VELOCIDAD_CAER          1
#define VELOCIDAD_ESCALERAS     1
#define VELOCIDAD_DISPARO_H     1
#define VELOCIDAD_DISPARO_V     2
#define MAX_LOOPS_HECHIZOS      1

// GENERALES
#define SI                  1
#define NO                  0
#define SEGUIR_JUGANDO      2
#define VOLVER_AL_MENU      1
#define MAX_BUCLE_CICLOS    20

// VIDEO
#define NUM_BUFFERS         2
#define VMEM_BUFFER1        (u8*) 0xC000
#define VMEM_BUFFER2        (u8*) 0x8000

// MÁSCARAS QUE TENDRÁ LA VARIABLE PROPIEDADES DE LAS ENTIDADES
#define mask_pintar             0b00000001  // Propiedad de las entidades que deben ser pintadas en cada ciclo de render
#define mask_activo             0b00000010  // Define si se tendrá en cuenta para las colisiones
#define mask_disparo_vertical   0b00000100  // Define si el personaje puede disparar en vertical
#define mask_destruir           0b00010000 // La entidad está en proceso de destruirse

// MÁSCARAS DE DIRECCIÓN DE PERSONAJES
#define mask_direccion_der      0b00000001
#define mask_direccion_izq      0b00000010
#define mask_direccion_baja     0b00000100
#define mask_direccion_sube     0b00001000

// MÁSCARAS PARA LAS OPCIONES DE bitOptions
#define mask_music_on           0b00000001
#define mask_sfx_on             0b00000010
#define mask_item_en_pantalla   0b00000100
#define mask_player1_inverse    0b00001000
#define mask_player0_inverse    0b00010000
#define mask_enable_countdown   0b00100000
#define mask_playing_game       0b01000000
#define mask_first_run          0b10000000
// #define mask_time_mode          0b10000000

// MÁSCARAS PARA LAS COLISIONES
#define mask_colision_inferior   0b00000001
#define mask_colision_izq        0b00000010
#define mask_colision_der        0b00000100
#define mask_escaleras_inferior  0b00001000
#define mask_escaleras_medio     0b00010000
#define mask_activar_switch      0b00100000

// MÁSCARAS PARA LOS HECHIZOS
#define mask_hechizo_activo      0b00000001

// TABLA DE TRANSPARENCIAS
cpctm_declareMaskTable(sp_tablaTrans);

extern const u8 sprites_player0[384];
extern const u8 sprites_player1[384];

extern u8* vmem_start;  // Inicio de la memoria de video del búffer actual
extern u8 vmem_page;    // Página de video actual (por lo del doble buffer)
extern u8 vmem_swap;    // Flag para saber si se tiene que alternar entre una memoria de video u otra (por lo del doble buffer)
extern u8 ciclo;        
extern u8 mapa_actual;
extern u8 selectedStage;
extern u16 mapa_halt_switch;
extern u8 mapa_id_cambio;
extern u8 mapa[TILES_TOTALES];
extern u8* mapa_ptr;
extern u8 backToMenu;
extern u8 anterior_id_item;
extern u8 bucle;
extern u8 contador_musica;
extern u8 velocidad_musica;
extern u8 opcionMenu;
extern u8 bitOptions;
extern u8 countdownSec;
extern u8 countdownMin;
extern u8 countdownInterrupt;

extern const u8 nomPersonajes[6][11];

typedef struct TJugador{
    i8 x;
    u8 y;
    i8 movimientoH;
    i8 movimientoV;
    u8 x_anterior, x_anterior2;
    u8 x_origen;
    u8 y_anterior, y_anterior2, y_origen;
    u8 estado;
    u8* sprite_frame[2];
    u8* sprite_escala_frame1;
    u8* sprite_escala_frame2;
    u8* sprite_disparando;    
    u8* sprite_herido; 
    u8 direccion;
    u8 mirando;
    i8 hechizos;
    i8 vidas;
    u8 disparando;
    u8 herido;
    u8 respawn;
    u8 skin;
    u8 velocidad;
    u8 velocidadDisparo;
    u8 wins;
    u16 hits;
    u16 shots;
    
} TJugador;
extern TJugador jugador[NUM_JUGADORES];

typedef struct THechizo{
    u8 tipo;
    i8 x;
    u8 y;
    i8 movimientoH;
    i8 movimientoV;
    u8 x_anterior, x_anterior2;
    u8 y_anterior, y_anterior2;
    u8* sprite_frame1;
    u8* sprite_destruir;
    u8 destruir;
    u8 velocidad;
    u8 loops;
    u8 propiedades;
} THechizo;
extern THechizo hechizo[MAX_OBJETOS_HECHIZO];

typedef struct TKey {
    cpct_keyID up;
    cpct_keyID down;
    cpct_keyID left;
    cpct_keyID right;
    cpct_keyID fire;
} TKey;
extern TKey key[NUM_JUGADORES];


///////////////////////////////////////
// DEFINICIO DE TIPOS DE ITEMS
//
// 2 - Hechizo
// 3 - Vida
// 4 - Cambio de skin
typedef struct TItem {
    u8 tipo;
    u8 x;
    u8 y;
    u8* sprite_frame;
    u8 propiedades;
    u8 destruir;
} TItem;
extern TItem item[MAX_OBJETOS_ITEM];

typedef struct TObjeto {
    u8 tipo;
    u8 x;
    u8 y;
} TObjeto;
extern TObjeto objeto[MAX_OBJETOS];
extern TObjeto* objetos_ptr;

void playSFX (u8 instrumento, u8 nota);
void playMusic();
void setInterruptAtVSYNCStart(void *intHdl);
void intHandler();
void seleccionarMonoBufer();
void borraPantallas();
void reproducirMusica();