#include <cpctelera.h>
#include "main.h"
#include "game.h"
#include "menu.h"
#include "render.h"
#include "font_utils.h"

// ==============================================================
// VACIAR EL BUFER DEL TECLADO:
//      CREA UN BUCLE DEL QUE NO SALE HASTA QUE SE HAN DEJADO DE PULSAR LAS TECLAS
// ==============================================================
void vaciaBufferTeclado() {
    while (cpct_isAnyKeyPressed()) {
        cpct_scanKeyboard();
    }
}

// ==============================================================
// CONTROLAR LAS PULSACIONES DE TECLAS DE LOS JUGADORES DURANTE EL JUEGO
// ==============================================================
void teclado() {
    
    // Primero ponemos a 0 todos los movimientos posibles
    jugador[0].movimientoV = jugador[0].movimientoH = jugador[1].movimientoV = jugador[1].movimientoH = 0;
    
    // Consultar el estado del teclado
    cpct_scanKeyboard();
    
    ////////////////////
    // JUGADOR 1
    ////////////////////
    //
    if (!jugador[0].disparando) {
        if (cpct_isKeyPressed(key[0].up) || cpct_isKeyPressed(Joy1_Up)) {
            jugador[0].movimientoV = ARRIBA;
            if (bitOptions & mask_player0_inverse) jugador[0].movimientoV = ABAJO;
        } else
        if (cpct_isKeyPressed(key[0].down) || cpct_isKeyPressed(Joy1_Down)) {
            jugador[0].movimientoV = ABAJO;
            if (bitOptions & mask_player0_inverse) jugador[0].movimientoV = ARRIBA;
        }
        if (cpct_isKeyPressed(key[0].left) || cpct_isKeyPressed(Joy1_Left)) {
            jugador[0].movimientoH = IZQUIERDA;
            jugador[0].direccion = mask_direccion_izq;
            if (bitOptions & mask_player0_inverse) {
                jugador[0].movimientoH = DERECHA;
                jugador[0].direccion = mask_direccion_der;
            }
        } else
        if (cpct_isKeyPressed(key[0].right) || cpct_isKeyPressed(Joy1_Right)) {
            jugador[0].movimientoH = DERECHA;
            jugador[0].direccion =  mask_direccion_der;
            if (bitOptions & mask_player0_inverse) {
                jugador[0].movimientoH = IZQUIERDA;
                jugador[0].direccion = mask_direccion_izq;
            }
        }
        if (cpct_isKeyPressed(key[0].fire) || cpct_isKeyPressed(Joy1_Fire1)) {
            disparar(0);
        }
    }
    //

    ////////////////////
    // JUGADOR 2
    ////////////////////
    //
    if (!jugador[1].disparando) {
        if (cpct_isKeyPressed(key[1].up) || cpct_isKeyPressed(Joy0_Up)) {
            jugador[1].movimientoV = ARRIBA;
            if (bitOptions & mask_player1_inverse) jugador[1].movimientoV = ABAJO;
        } else 
        if (cpct_isKeyPressed(key[1].down) || cpct_isKeyPressed(Joy0_Down)) {
            jugador[1].movimientoV = ABAJO;
            if (bitOptions & mask_player1_inverse) jugador[1].movimientoV = ARRIBA;
        }
        if (cpct_isKeyPressed(key[1].left) || cpct_isKeyPressed(Joy0_Left)) {
            jugador[1].movimientoH = IZQUIERDA;
            jugador[1].direccion = mask_direccion_izq;
            if (bitOptions & mask_player1_inverse) {
                jugador[1].movimientoH = DERECHA;
                jugador[1].direccion = mask_direccion_der;
            }
        } else
        if (cpct_isKeyPressed(key[1].right) || cpct_isKeyPressed(Joy0_Right)) {
            jugador[1].movimientoH = DERECHA;
            jugador[1].direccion = mask_direccion_der;
            if (bitOptions & mask_player1_inverse) {
                jugador[1].movimientoH = IZQUIERDA;
                jugador[1].direccion = mask_direccion_izq;
            }
        }
        if (cpct_isKeyPressed(key[1].fire) || cpct_isKeyPressed(Joy0_Fire1)) {
            disparar(1);
        }
    }
    //

    ////////////////////
    // GENERALES
    ////////////////////
    //
    if (cpct_isKeyPressed(Key_Esc)) {
        backToMenu = 1;     
    }

    // **** DEBUG ***
        /*
        if (cpct_isKeyPressed(Key_Space)) {
            crearItem();
        }
        */
        /*
        if (cpct_isKeyPressed(Key_K)) {
            seleccionarSkin(0, SKIN_RANDOM);
        }
        */
        /*
        if (cpct_isKeyPressed(Key_9)) {
            modificaMarcadorVida(0, 1);
        }
        */
        /*
        if (cpct_isKeyPressed(Key_0)) {
            modificaMarcadorHechizos(0, 1);
        }
        */
    // **** DEBUG ***
 
}


///////////////////////////////////////////////////////////////////////////////////
// REDEFINIR TECLAS
///////////////////////////////////////////////////////////////////////////////////

// Función proporcionada por ronaldo para redefinir los controles
cpct_keyID esperaUnaTecla() {
    // Recorreremos el vector de teclas desde el final hacia el principio,
    // para poder hacer que el bucle acabe en 0 (así el compilador podrá optimizarlo)
    u8 i = 10, *keys = cpct_keyboardStatusBuffer + 9;
    u16 keypressed;

    // Esperamos hasta que se pulse una tecla
    do { cpct_scanKeyboard(); 
    } while (!cpct_isAnyKeyPressed());

    // Detectamos la tecla que ha sido pulsada
    do {
        // Si en este grupo de 8 teclas hay una pulsada, alguno de los bits estará a 0
        // En caso contrario, todos estarán a 1, y un XOR con 0xFF dará 0 (false) como resultado
        keypressed = *keys ^ 0xFF;
        if (keypressed)
            return (keypressed << 8) + (i - 1);  // Formato cpct_keyID: 8 primeros bits = máscara de tecla, 8 siguientes fila del teclado (0-9)
        keys--;
    } while (--i);
    return (keypressed << 8) + (i - 1);
}

cpct_keyID redefineKey(u8 text[]){
    cpct_keyID key;
    cpct_drawSolidBox(cpct_getScreenPtr((VMEM_BUFFER1), 35, 120), 0, 12, 8);
    printTxt(text, CENTRADO, 120, NO, 0);
    vaciaBufferTeclado();
    key = esperaUnaTecla();
    sonidoTecla();
    vaciaBufferTeclado();
    return key;
}